.get.mip <-
function(object)
{
	if("ped.get.genotypes.012"==object$ped.predictor)
	{
		return(rowSums(object$inc.mat!=0)/ncol(object$inc.mat))
	}
	if("ped.get.dosage"==object$ped.predictor)
	{
		return(rowSums(object$inc.mat!=0)/ncol(object$inc.mat))
	}
	if("ped.get.dom.pred"==object$ped.predictor)
	{
		add.markers<-(object$inc.mat!=0)[1:(nrow(object$inc.mat)/2),]
		dom.markers<-(object$inc.mat!=0)[((nrow(object$inc.mat)/2)+1):nrow(object$inc.mat),]
		combined.markers<-((dom.markers+add.markers)!=0)
		return(rowSums(combined.markers)/ncol(combined.markers))
	}
	if("ped.get.prob.pred"==object$ped.predictor)
	{
		add.markers<-(object$inc.mat!=0)[1:(nrow(object$inc.mat)/2),]
		dom.markers<-(object$inc.mat!=0)[((nrow(object$inc.mat)/2)+1):nrow(object$inc.mat),]
		combined.markers<-((dom.markers+add.markers)!=0)
		return(rowSums(combined.markers)/ncol(combined.markers))
	}
}
.mbm <-
function (ped, family)
{
	y<-ped.get.phenotype(ped)
	x<-ped.get.genotypes.012(ped)
	x.dom<-x
	x.dom[x!=1]<-0
	fit.0<-glm(y~1, family=family)
	pval.add<-vector()
	pval.dom<-vector()
	for(i in 1:ncol(x))
	{
		fit.add<-glm(y~1+x[,i], family=family)
		fit.dom<-glm(y~1+x[,i]+x.dom[,i], family=family)
		pval.add[i]<- pchisq(-2*(logLik(fit.0)[1]-logLik(fit.add)[1]),df=1,lower.tail=F)
		pval.dom[i]<- pchisq(-2*(logLik(fit.0)[1]-logLik(fit.dom)[1]),df=2,lower.tail=F)
	}
	retval<-list(add=pval.add,dom=pval.dom)
	retval
}
.ped.find.markers <-
function(ped, markers.i=NULL, markers=NULL, default.all=TRUE)
{
	if (!is.null(markers.i))
	{
		if (any(is.na(ped.get.markers(ped)[markers.i])))
		{
			stop("invalid markers requested")
		}
		if (0==length(markers.i))
		{
			stop("No markers requested")
		}
		return (markers.i)
	}
	if (is.null(markers))
	{
		if (default.all)
		{
			return (1:ped.get.num.markers(ped))
		}
		stop("No markers requested")
	}
	if (0==length(markers))
	{
		stop("No markers reqested")
	}
	markers.i <- match(markers, ped.get.markers(ped))
	if (any(is.na(markers.i)))
	{
		stop("some unknown markers specified\n")
	}
	markers.i
}
.ped.find.subjects <-
function(ped, subjects.i=NULL, subjects=NULL, default.all=TRUE)
{
	if (!is.null(subjects.i))
	{
		if (any(is.na(ped.get.subjects(ped)[subjects.i])))
		{
			stop("invalid subjects requested")
		}
		if (0==length(subjects.i))
		{
			stop("No subjects requested")
		}
		return (subjects.i)
	}
	if (is.null(subjects))
	{
		if (default.all)
		{
			return (1:ped.get.num.subjects(ped))
		}
		stop("No markers requested")
	}
	if (0==length(subjects))
	{
		stop("No subjects reqested")
	}
	subjects.i <- match(subjects, ped.get.subjects(ped))
	if (any(is.na(subjects.i)))
	{
		stop("some unknown subjects specified\n")
	}
	subjects.i
}
.ped.init.fake.haplotypes <-
function(ped)
{
	g012 <- hash.get(ped, "genotypes.012")
	names.rowscols <- list(ped.get.subjects(ped), ped.get.markers(ped))
	hap1 <- matrix(NA, nrow=nrow(g012), ncol=ncol(g012), dimnames=names.rowscols)
	hap2 <- matrix(NA, nrow=nrow(g012), ncol=ncol(g012), dimnames=names.rowscols)

	mask <- 0==g012
	hap1[mask] <- 0
	hap2[mask] <- 0

	mask <- 1==g012
	hap1[mask] <- 0
	hap2[mask] <- 1

	mask <- 2==g012
	hap1[mask] <- 1
	hap2[mask] <- 1

	hash.put(ped, "haplotype.1", hap1)
	hash.put(ped, "haplotype.2", hap2)
}
