FReMA <-
function(ped, num.resamples=100, family="gaussian", penalty="standard", model="dom", resample="fractional", resample.mat=NULL, rand.alpha=0.7)
{
	if(model %in% c("additive","dom","dosage","prob")){}
	else {stop(paste("invalid model option", model))}
	
	if("fractional"==resample)
	{
		if("dom"==model)
		{
			return( wgrpllarrma(ped, penalty=switch(penalty, "standard"="lasso", "randomized"="rand.lasso"), weights=resample.mat, num.resamples=num.resamples, family=family, ped.get.predictors=ped.get.dom.pred, rand.alpha=rand.alpha)  )
		}
		if("additive"==model)
		{
			return( wllarrma(ped, penalty=switch(penalty, "standard"="lasso", "randomized"="rand.lasso"), weights=resample.mat, num.resamples=num.resamples, family=family, ped.get.predictors=ped.get.genotypes.012, rand.alpha=rand.alpha)  )
		}
		if("dosage"==model)
		{
			return( wllarrma(ped, penalty=switch(penalty, "standard"="lasso", "randomized"="rand.lasso"), weights=resample.mat, num.resamples=num.resamples, family=family, ped.get.predictors=ped.get.dosage, rand.alpha=rand.alpha)  )
		}
		if("prob"==model)
		{
			return( wgrpllarrma(ped, penalty=switch(penalty, "standard"="lasso", "randomized"="rand.lasso"), weights=resample.mat, num.resamples=num.resamples, family=family, ped.get.predictors=ped.get.prob.pred, rand.alpha=rand.alpha)  )
		}
	}
	else if("subsample"==resample)
	{
		if("dom"==model)
		{
			stop("Subsample not a valid option for Dominance model")
		}
		if("additive"==model)
		{
			return( llarrma(ped, penalty=switch(penalty, "standard"="lasso", "randomized"="rand.lasso"), subsamples=resample.mat, num.resamples=num.resamples, family=family, ped.get.predictors=ped.get.genotypes.012, rand.alpha=rand.alpha) )
		}
		if("dosage"==model)
		{
			return( llarrma(ped, penalty=switch(penalty, "standard"="lasso", "randomized"="rand.lasso"), subsamples=resample.mat, num.resamples=num.resamples, family=family, ped.get.predictors=ped.get.dosage, rand.alpha=rand.alpha) )
		}
	}
	else {stop("invalid option for resample")}
	
	

}
