gen.rand.lasso.weights <-
function(nc, alpha, type="unif")
{
	if(length(type)!=1)
	{
		stop("must specify only 1 value for type")
	}
	if("flip"==type)
	{
		W.g=rbinom(nc,1,.5)
		W<-W.g*alpha+(1-W.g)
		return(W)
	}
	if("unif"==type)
	{
		W<-runif(nc,alpha,1)
		return(W)
	}
	if("inv"==type)
	{
		W<-runif(nc,1,1/alpha)
		return(1/W)
	}
	if("dir"==type)
	{
		W<-diff(sort(c(0,1,runif(nc-1,0,1))))
		return(W)
	}
	stop("invalid type")
}
