get.max.lambda.perm <-
function(object, n.perm=20, quart=NULL, type="median",penalty=c("lasso","rand.lasso"), rand.alpha=0.7, family="binomial")
{
	lambda<-NULL
	if(length(penalty)!=1){stop("must specify only one penalty")}
	if("lasso"==penalty)
	{
		for(ii in 1:n.perm)
		{
			pheno<-sample(object$sub.response)
			model<-glmnet(object$sub.data ,pheno, family=family,lambda.min=.9, nlambda=3, standardize=F)
			lambda[ii]=max(model$lambda)
		}
	}
	if("rand.lasso"==penalty)
	{
		for(ii in 1:n.perm)
		{
			pheno<-sample(object$sub.response)
			model<-glmnet(object$sub.rand ,pheno, family=family,lambda.min=.9, nlambda=3, standardize=F)
			lambda[ii]=max(model$lambda)
		}
	}	
	if("max"==type)
	{
		return(max(lambda))
	}
	if("median"==type)
	{
		return(median(lambda))
	}
	stop("invalid type option")	
}
