get.max.lambda.perm.weight <-
function(ped, n.perm=20, penalty=c("lasso","rand.lasso"), family="binomial", weight, ped.get.predictors, wtype="unif", rand.alpha=.7)
{
	lambda<-NULL
	phenotype=ped.get.phenotype(ped)	
	if("lasso"==penalty)
	{
		data<-ped.get.predictors(ped,center=T)
		for(ii in 1:n.perm)
		{
			pheno<-sample(phenotype)
			model<-glmnet(data, pheno, family=family,lambda.min=.9, weights=weight, nlambda=3, standardize=F)
			lambda[ii]=max(model$lambda)
		}
		return(median(lambda))
	}
	if("rand.lasso"==penalty)
	{
		if(is.null(wtype))
		{
			stop("you must specify a rand.wtype")
		}
		W<-gen.rand.lasso.weights(ped.get.num.markers(ped), alpha=rand.alpha, type=wtype)
		data.r<-ped.get.predictors(ped,center=T, rand=T,W=W)
		for(ii in 1:n.perm)
		{
			pheno<-sample(phenotype)
			model<-glmnet(data.r, pheno, family=family, lambda.min=.9, weights=weight, nlambda=3, standardize=F)
			lambda[ii]=max(model$lambda)
		}
		return(list(lambda=median(lambda),rand.weight=W))
	}		
}
