get.max.lambda.perm.weight.grp <-
function(ped, n.perm=20, weight=NULL, penalty="lasso", index=NULL, family="binomial", ped.get.predictors, wtype, rand.alpha, ...)
{
	lambda<-NULL
	if("lasso"==penalty)
	{
		data<-cbind(1,ped.get.predictors(ped,center=T))
		phenotype<-ped.get.phenotype(ped)
		for(ii in 1:n.perm)
		{
			pheno<-sample(phenotype)
			lambda[ii]<-lambdamax(x=data, y=pheno, weights=weight, index=index, penscale = sqrt, model = switch(family, binomial = LogReg(), gaussian = LinReg()), center=F, standardize=F)
		}
		return(median(lambda))
	}
	if("rand.lasso"==penalty)
	{
		phenotype<-ped.get.phenotype(ped)
		if(is.null(wtype))
		{
			stop("you must specify a rand.wtype")
		}		
		W<-gen.rand.lasso.weights(ped.get.num.markers(ped),alpha=rand.alpha, type=wtype)
		r.data<-cbind(1,ped.get.predictors(ped,center=T, rand=T,W=W))
		for(ii in 1:n.perm)
		{
			pheno<-sample(phenotype)
			lambda[ii]=lambdamax(x=r.data, y=pheno, weights=weight, index=index, penscale = sqrt, model = switch(family, binomial = LogReg(), gaussian = LinReg()), center=F, standardize=F)
		}
		return(list(lambda=median(lambda),rand.weight=W))
	}
}
