new.ped <-
function(subjects, markers, genotypes.012, father, mother, family.id, sex, phenotype)
{
	ped <- new.hash()

	num.subjects <- length(subjects)
	num.markers  <- length(markers)
	if (0==num.subjects | 0==num.markers)
	{
		stop("must have a non-zero number of subjects and markers")
	}
	if (length(unique(subjects))!=length(subjects))
	{
		stop("subject names are not unique")
	}
	if (length(unique(markers))!=length(markers))
	{
		stop("markers names are not unique")
	}
	if (!all(num.subjects == c(length(family.id), length(mother), length(father), length(sex), length(phenotype))))
	{
		stop("wrong numbers of family/father/mother/sex/phenotype information")
	}
	if (num.subjects!=nrow(genotypes.012) | num.markers!=ncol(genotypes.012))
	{
		stop("genotype matrix should be ", num.subjects, " x ", num.markers, ". Got ", nrow(genotypes.012), " x ", ncol(genotypes.012))
	}

	colnames(genotypes.012) <- markers
	rownames(genotypes.012) <- subjects

	hash.put(ped, "subject.names", subjects)
	hash.put(ped, "marker.names", markers)
	hash.put(ped, "family.id", family.id)
	hash.put(ped, "father", father)
	hash.put(ped, "mother", mother)
	hash.put(ped, "sex", sex)
	hash.put(ped, "phenotype", phenotype)
	hash.put(ped, "genotypes.012", genotypes.012)
	class(ped) <- "ped"
	ped
}
