ped.get.prob.pred <-
function(ped, subjects.i=NULL, subjects=NULL, markers.i=NULL, markers=NULL, center=F, rand=F, W=NULL)
{ 
	subjects.i <- .ped.find.subjects(ped, subjects.i=subjects.i, subjects=subjects, default.all=TRUE)
	markers.i <- .ped.find.markers(ped, markers.i=markers.i, markers=markers, default.all=TRUE)

	geno<-hash.get(ped, "dosage")[subjects.i, markers.i]
	dom<-hash.get(ped, "pQq")[subjects.i, markers.i]
	dom[geno!=1]<-0
	if(center==F)
	{
		
		if(F==rand)
		{
			return(cbind(geno,dom))	
		}
		if (T==rand)
		{
			if(is.null(W))
			{
				stop("must provide a W for randomization")
			}
			return(  (cbind(geno,dom)) %*% diag(c(W,W)) )
		}
	}
	if(T==center)
	{
		means.geno<- apply(geno,2,mean)
		mat.mean<-t(matrix(rep(means.geno,nrow(geno)),ncol=nrow(geno)))  #note, not sure how to best center so skipped for now
		if(F==rand)
		{
			return(cbind((geno),(dom)))
		}
		if (T==rand)
		{
			if(is.null(W))
			{
				stop("must provide a W for randomization")
			}
			return(  (cbind((geno),(dom))) %*% diag(c(W,W)) )
		}	
	}
	stop("invalid options for ped.get.dom.pred")
}
