ped.read.fastphase.hapdraws <-
function(ped.template, file, haplotypes=FALSE, verbose.every=100)
{
	lines <- readLines(file)
	lines <- lines[""!=lines]

	num.subjects <- ped.get.num.subjects(ped.template)
	num.samples  <- length(lines)/(2*num.subjects + 1)

	if (num.samples != round(num.samples))
	{
		stop("Number of non-blank lines ", length(lines),
				" is inconsistent with ", num.subjects, " subjects")
	}

	names.rowcol <- list(ped.get.subjects(ped), ped.get.markers(ped))
	ped.list <- list()
	for (s in 1:num.samples)
	{
		if (s %% verbose.every == 0) cat(sep="", "[",s,"]")

		header.i <- 1 + (s-1)*(2*num.subjects + 1)
		hap.i <- header.i + 2*(1:num.subjects) - 1
		haplotype.1 <- t(sapply(strsplit(lines[hap.i], split="", fixed=TRUE), as.integer))
		haplotype.2 <- t(sapply(strsplit(lines[1+hap.i], split="", fixed=TRUE), as.integer))
		genotypes.012 <- haplotype.1 + haplotype.2
		dimnames(genotypes.012) <- names.rowcol

		ped <- ped.clone(ped.template)
		hash.put(ped, "genotypes.012", genotypes.012)
		if (haplotypes)
		{
			dimnames(haplotype.1) <- names.rowcol
			hash.put(ped, "haplotype.1", haplotype.1)
			dimnames(haplotype.2) <- names.rowcol
			hash.put(ped, "haplotype.2", haplotype.2)
		}
		ped.list[[s]] <- ped
	}
	ped.list
}
