ped.read.fastphase.hapguess <-
function(ped.template, file, haplotypes=FALSE)
{
	num.subjects <- ped.get.num.subjects(ped.template)
	names.rowcol <- list(ped.get.subjects(ped), ped.get.markers(ped))

	#read file
	lines <- readLines(file, warn=FALSE)
	start.i <- grep("BEGIN GENOTYPES", lines)
	end.i   <- grep("END GENOTYPES", lines)
	if (0==length(start.i) | 0==length(end.i))
	{
		stop("Could not find enclosing BEGIN GENOTYPES and END GENOTYPES statements")
	}

	hap.i <- start.i + 3*(1:num.subjects) - 1
	haplotype.1 <- t(sapply(strsplit(lines[hap.i], split=" ", fixed=TRUE), as.integer))
	haplotype.2 <- t(sapply(strsplit(lines[1+hap.i], split=" ", fixed=TRUE), as.integer))
	genotypes.012 <- haplotype.1 + haplotype.2
	dimnames(genotypes.012) <- names.rowcol

	ped <- ped.clone(ped.template)
	hash.put(ped, "genotypes.012", genotypes.012)
	if (haplotypes)
	{
		dimnames(haplotype.1) <- names.rowcol
		hash.put(ped, "haplotype.1", haplotype.1)
		dimnames(haplotype.2) <- names.rowcol
		hash.put(ped, "haplotype.2", haplotype.2)
	}
	ped
}
