plot.FReMA <-
function(object,pch=16, col="black",xlab="SNPs",title.str=NULL, ...)
{
	RMIP<-.get.mip(object)
	if(is.null(title.str))
	{
		title.str<-paste("FreMA: ",switch(object$ped.predictor, "ped.get.genotypes.012"="Additive only", "ped.get.dom.pred"="Additive and Dominance")," model using ",switch(object$resample, "fractional"="fractional-resampling", "subsample"="subsampling"),sep="")
	}
	par(las=1)
	plot(1:length(RMIP),RMIP, ylim=c(0,1),pch=pch,col=col, axes=F, ylab="RMIP", xlab="")
	title(main=title.str)
	title(xlab=xlab,line=2)
	axis(2)
	Xpts<-seq(from=0,to=object$num.predictors, by=25)
	Xpts[1]<-1
	Xpts[length(Xpts)+1]<-object$num.predictors
	axis(1,at=Xpts )
}
