read.ped <-
function(file, phased=FALSE, cols.per.genotype=1, header=TRUE)
{
	raw.data <- read.table(file, header=header)

	markers <- NULL
	if (header)
	{
		markers <- colnames(raw.data)[-c(1:6)]
	}
	else
	{
		markers <- paste(sep="", "m", 1:(ncol(raw.data)-6))
	}

	genotypes.012 <- as.matrix(raw.data[,-c(1:6)])

	ped <- new.ped(
		subjects = as.character(raw.data[,2]),
		markers = markers,
		family.id = as.character(raw.data[,1]),
		father = as.character(raw.data[,3]),
		mother = as.character(raw.data[,4]),
		sex = as.character(raw.data[,5]),
		phenotype = raw.data[,6],
		genotypes.012 = genotypes.012)

	ped
}
