subsample.select <-
function(ped, indicies, iteration=NULL, randomized=NULL, rand.alpha=0.7, wtype="unif", ped.get.predictors)
{
   i<-iteration
	if(is.list(ped))
	{
		data.mc<-ped.get.predictors(ped[[i]],center=T)
		pheno<-ped.get.phenotype(ped[[i]])
	}
	else
	{
		data.mc<-ped.get.predictors(ped,center=T) 
		pheno<-ped.get.phenotype(ped)
	}
		if(!is.null(randomized))
		{		
			if(ncol(data.mc)==ped.get.num.markers(ped))
			{
				W<-gen.rand.lasso.weights(ped.get.num.markers(ped),alpha=rand.alpha, type=wtype)
				sub.rand<-data.mc[indicies[,i],]%*%diag(W)  
				sub.data<-data.mc[indicies[,i],]
				sub.response<-pheno[indicies[,i]]
				comp.rand<-data.mc[-indicies[,i],]%*%diag(W)
				comp.data<-data.mc[-indicies[,i],]
				comp.response<-pheno[-indicies[,i]]
			}
			else if(ncol(data.mc)== (2*ped.get.num.markers(ped)))
			{
				W<-gen.rand.lasso.weights(ped.get.num.markers(ped),alpha=rand.alpha, type=wtype)
				W1=c(W,W)
				sub.rand<-data.mc[indicies[,i],]%*%diag(W1)  
				sub.data<-data.mc[indicies[,i],]
				sub.response<-pheno[indicies[,i]]
				comp.rand<-data.mc[-indicies[,i],]%*%diag(W1)
				comp.data<-data.mc[-indicies[,i],]
				comp.response<-pheno[-indicies[,i]]
			}
			else {stop("no randomized lasso option for given ped.get.predictors  (use genotype or dominance)")}
			
			retval<-list(sub.rand=sub.rand, sub.data=sub.data, sub.response=sub.response, comp.rand=comp.rand, comp.data=comp.data, comp.response=comp.response, rand.weight=W)
		}
		else
		{
			sub.data<-data.mc[indicies[,i],]
			sub.response<-pheno[indicies[,i]]
			comp.data<-data.mc[-indicies[,i],]
			comp.response<-pheno[-indicies[,i]]        
			retval<-list(sub.data=sub.data, sub.response=sub.response,comp.data=comp.data, comp.response=comp.response)
		}
		retval
	}
