subsamples.llarrma <-
function(ped, proportion=2/3, num.subsamples=1000, family=c("gaussian","binomial"), subsample.type=c("balanced", "proportional"),ped.get.predictors=ped.get.genotypes.012) 
{
   if(1!=length(family))
	{
		stop("Must specify a single model family")
	}
	if("binomial"==family) 
	{
		if (1!=length(subsample.type))
		{
			stop("must specify a single subsample type")
		}
		if( is.list(ped) )
    	{
        	ped<-ped[[1]]
    	}
		
    	response<-ped.get.phenotype(ped)
    	nr<-ped.get.num.subjects(ped)
    	if(subsample.type=="balanced")
		{
			indices.0<-order(response==1)[1:sum(response==0)]
	    	indices.1<-order(response==0)[1:sum(response==1)]  
	    	subsamples<-matrix(nrow=2*floor(1/2*proportion*nr),ncol=num.subsamples)
	    	for(i in 1:num.subsamples)    
	    	{
	        	subsamp.0 <- sample(indices.0, size=floor(1/2*proportion*nr), replace=FALSE)
	        	subsamp.1 <- sample(indices.1, size=floor(1/2*proportion*nr), replace=FALSE)
	        	subsamp.indices<-c(subsamp.0,subsamp.1)
	        	subsamples[,i]<-subsamp.indices
	    	}
		}
		else if(subsample.type=="proportional")
		{
			indices.0<-order(response==1)[1:sum(response==0)]
	    	indices.1<-order(response==0)[1:sum(response==1)]  
	    	subsamples<-matrix(nrow=floor(proportion*length(indices.0))+floor(proportion*length(indices.1)),ncol=num.subsamples)
	    	for(i in 1:num.subsamples)    
	    	{
	        	subsamp.0 <- sample(indices.0, size=floor(proportion*length(indices.0)), replace=FALSE)
	        	subsamp.1 <- sample(indices.1, size=floor(proportion*length(indices.1)), replace=FALSE)
	        	subsamp.indices<-c(subsamp.0,subsamp.1)
	        	subsamples[,i]<-subsamp.indices
	    	}
		}
		else {stop("must specify a valid subsample.type")}
   }
 	if("gaussian"==family) 
	{
		if( is.list(ped) )
    	{
        	ped<-ped[[1]]
    	}
    	response<-ped.get.phenotype(ped)
    	nr<-ped.get.num.subjects(ped)
		subsamples<-matrix(nrow=floor(proportion*nr),ncol=num.subsamples)
    	for(i in 1:num.subsamples)    
    	{
        	subsamp.indices<-sample(1:nr, size=floor(proportion*nr), replace=FALSE)
        	subsamples[,i]<-subsamp.indices
    	}
	}
	subsamples
}
