wgrpllarrma <-
function(ped, penalty=c("lasso","rand.lasso"), method.lambda="perm", weights=NULL, weight.method="uniform", num.resamples=1000, family=c("gaussian","binomial"), min.lambda=.001,ped.get.predictors=ped.get.genotypes.012,  rand.alpha=0.7, rand.wtype="flip" )
{
	if(1!=length(family) )
   	{
		stop("Only one family may be specified \n")
	}
   	if (1!=length(penalty))
   	{
		stop("only one of lasso/rand.lasso can be run at a time \n")
   	}
	if(1!=length(method.lambda))
	{
		stop("Only one method for lambda selection can be specified \n")
	}
   	retval<-NULL
	retval$resample<-"fractional"
   	retval$penalty<-switch(penalty, "lasso"="group LASSO", "rand.lasso"=paste("Randomized group LASSO with alpha = ", rand.alpha, sep=""))
	retval$family<-family
	retval$method.lambda<-switch(method.lambda, "perm"= "Permutation Selection", "comp.dev"="Complement Deviance Selection")
	retval$ped.predictor<-deparse(substitute(ped.get.predictors))
	retval$num.resamples<-num.resamples 

   	if( is.list(ped) )
   	{
		retval$inc.mat<-matrix(0,nrow=ncol(ped.get.predictors(ped[[1]])),ncol=cnum.resamples)
		retval$lambdas<-NULL
		retval$predictors<-ped.get.markers(ped[[1]])
		retval$num.subjects<-ped.get.num.subjects(ped[[1]])
		retval$num.predictors<-ped.get.num.markers(ped[[1]])
	}
   	else
   	{
     	retval$inc.mat<-matrix(0,nrow=ncol(ped.get.predictors(ped)),ncol=num.resamples)
		retval$lambdas<-NULL
		retval$predictors<-ped.get.markers(ped)
		retval$num.subjects<-ped.get.num.subjects(ped)
		retval$num.predictors<-ped.get.num.markers(ped)
 	}
   if(is.null(weights))
   {
     	weights<-weights.llarrma(ped, num.resamples=num.resamples, family=family, weight.type=weight.method, ped.get.predictors=ped.get.predictors)
   }
	group.index=rep(1:ped.get.num.markers(ped),2)
	if(penalty=="lasso")
   {
		if("perm"==method.lambda)
		{
			for(i in 1:num.resamples)
			{
				if (i %% 10 == 0) cat(sep="", "[",i,"]")
				retval$lambdas[i]<-get.max.lambda.perm.weight.grp(ped, n.perm=20, type="median", penalty="lasso", weight=weights[,i], index=c(NA,group.index), family=family,ped.get.predictors=ped.get.predictors)
				model.perm<-grplasso(x=cbind(1,ped.get.predictors(ped,center=T)),y=ped.get.phenotype(ped),weight=weights[,i], index=c(NA,group.index), lambda=retval$lambdas[i], model=switch(family, binomial = LogReg(), gaussian = LinReg()), penscale=sqrt, control=grpl.control(update.hess="lambda", trace=0), standardize=F,center=F)
				retval$inc.mat[,i]<-model.perm$coefficients[-1,]
		   	}
		}
	}
   	if(penalty=="rand.lasso")
   	{
	retval$rand.lasso.weights<-matrix(NA, nrow=ped.get.num.markers(ped), ncol=num.resamples)
	retval$rand.wtype=rand.wtype
      	if("perm" == method.lambda)
		{
			for(i in 1:num.resamples)
			{
				if (i %% 10 == 0) cat(sep="", "[",i,"]")
				lambdas.rand<-get.max.lambda.perm.weight.grp(ped, n.perm=20,  penalty="rand.lasso", rand.alpha=rand.alpha,  weight=weights[,i],index=c(NA,group.index), family=family, ped.get.predictors=ped.get.predictors,wtype=rand.wtype)
				retval$lambdas[i]<-lambdas.rand$lambda
				retval$rand.lasso.weights[,i]=lambdas.rand$rand.weight
				model.perm<-grplasso(x=cbind(1,ped.get.predictors(ped,center=T, rand=T,W=lambdas.rand$rand.weight)),y=ped.get.phenotype(ped), weight=weights[,i], index=c(NA,rep(1:ped.get.num.markers(ped),2)), lambda=retval$lambdas[i], model=switch(family, binomial = LogReg(), gaussian = LinReg()), penscale=sqrt, control=grpl.control(update.hess="lambda", trace=0), standardize=F,center=F)
				retval$inc.mat[,i]<-model.perm$coefficients[-1,]
			}
		}
  	}
	class(retval)<-"FReMA"
	retval  
}
